/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/model/rulesEngine/langParser/ExpressionParser                 */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesEngine.langParser;

import org.springframework.stereotype.Service;
import lombok.extern.slf4j.Slf4j;
import org.mvel2.MVEL;
import java.util.Map;

@Slf4j
@Service
public class ExpressionParser {

    public boolean parseExpression( String expression, Map<String, Object> inputObjects, String type) {
        if (expression.isEmpty()) { expression = "true==true"; }
        try {
            return MVEL.evalToBoolean(expression, inputObjects);
        } catch (Exception e) {
            if (type.equals("input")) { log.error("Please check ruleset for errors."); }
        }
        return false;
    }
}
