/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/model/rulesEngine/langParser/KeywordParser                    */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesEngine.langParser;

import org.springframework.stereotype.Service;
import com.google.common.base.Splitter;
import com.google.common.collect.Lists;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.ArrayList;
import java.util.List;

@Service
public class KeywordParser {
    private static final Pattern PATTERN = Pattern.compile("\\$\\((\\w+)(\\.\\w+)\\)");
    private static final String DOT = ".";

    public List<String> getListOfKeywords(String expression) {
        Matcher matcher = PATTERN.matcher(expression);
        List<String> matchingKeywords = new ArrayList<>();
        while (matcher.find()) {
            String group = matcher.group();
            matchingKeywords.add(group);
        }
        return matchingKeywords;
    }

    public String extractKeyword(String keyword) {
        return keyword.substring(keyword.indexOf('(') + 1,
                keyword.indexOf(')'));
    }

    public String getKeywordResolver(String keyphrase) {
        ArrayList<String> splitKeyword = Lists.newArrayList(Splitter.on(DOT).omitEmptyStrings().split(keyphrase));
        return splitKeyword.get(0);
    }

    public String getKeywordValue(String keyphrase) {
        ArrayList<String> splitKeyword = Lists.newArrayList(Splitter.on(DOT).omitEmptyStrings().split(keyphrase));
        return splitKeyword.get(1);
    }
}