/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/model/rulesEngine/langParser/RuleParser                       */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.model.rulesEngine.langParser;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.HashMap;
import java.util.Map;

@Service
public class RuleParser<InputPayload, OutputPayload> {

    @Autowired
    protected VariableParser variableParser;
    @Autowired
    protected ExpressionParser expressionParser;

    private final String INPUT = "input";
    private final String OUTPUT = "output";

    public boolean parseCondition(String expression, InputPayload inputData) {
        String resolvedExpression = variableParser.resolveKeywords(expression);
        Map<String, Object> input = new HashMap<>();
        input.put(INPUT, inputData);
        boolean match = expressionParser.parseExpression(resolvedExpression, input, INPUT);
        return match;
    }

    public OutputPayload parseAction(String expression, InputPayload inputPayload, OutputPayload outputPayload) {
        String resolvedExpression = variableParser.resolveKeywords(expression);
        Map<String, Object> input = new HashMap<>();
        input.put(INPUT, inputPayload);
        input.put(OUTPUT, outputPayload);
        expressionParser.parseExpression(resolvedExpression, input, OUTPUT);
        return outputPayload;
    }
}