/* Parham Data Products                                                      */
/* Expert Rules Engine                                                       */
/* main/expert/services/databaseService/RuleId                               */
/* Copyright 2020 Wayne Parham                                               */

package com.parhamdata.expert.services.databaseService;

import lombok.Data;
import java.io.Serializable;

@Data
public class RuleId implements Serializable {
    protected String domain;
    protected Integer id;

    public RuleId() {
    }

    public RuleId(String domain, Integer id) {
        this.domain = domain;
        this.id = id;
    }

    @Override
    public int hashCode() {
        int result = id;
        if( domain != null) { result += domain.hashCode(); }
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        RuleId other = (RuleId) obj;
        if (domain == null) {
            if (other.domain != null)
                return false;
        } else if (!domain.equals(other.domain))
            return false;
        return id == other.id;
    }
}